PROGRAM test_ser;

Device = mega644P;


CONST

  BAUDRATE : WORD = 25253;

  // ((ProcClock+BAUDRATE*8)/(BAUDRATE*16)-1)
  // (((25253*8)+20000000)/(25253*16))-1) = ((202024+20000000)/404048)-1 =
  // (20202024/404048)-1 = 50-1 = 49
  UBRR_VAL : WORD = 49;
  XON  : Byte = $11;
  XOFF : Byte = $13;

VAR
  PORTD, DDRD, PIND, PORTC, DDRC, PINC, 
  PORTB, DDRB, PINB, PORTA, DDRA, PINA : ByteConReg; 

  UBRR0H, UBRR0L, UCSR0C, UCSR0B, UCSR0A, UDR0 : ByteConVar;
  UBRR0 : WordConVar;


  RXC0[UCSR0A,7] : Bit;
  TXC0[UCSR0A,6] : Bit;
  UDRE0[UCSR0A,5] : Bit;


  LED_ROT[PORTD,7] : Bit;

  Zeichen : Byte;




//
empfangenes_Zeichen : Byte;


procedure INIT_SER_PORT;
begin

{
 Initialisieren der seriellen Schnittstelle
 ---------------------------------------------

; festlegen der Baudrate fuer die serielle Schnittstelle
}

    UBRR0 := UBRR_VAL;

{
Bit 3 ? TXEN: Transmitter Enable
Writing this bit to one enables the USART Transmitter. The Transmitter will override normal
port operation for the TxD pin when enabled. The disabling of the Transmitter
(writing TXEN to zero) will not become effective until ongoing and pending transmissions
are completed (i.e., when the Transmit Shift Register and Transmit Buffer Register
do not contain data to be transmitted). When disabled, the Transmitter will no longer
override the TxD port.
}

    UCSR0B := %00011000;

{

URSEL UMSEL UPM1 UPM0 USBS UCSZ1 UCSZ0 UCPOL
    1     0    0    0    0     1     1     0

; Set comms parameters ---> BITS = 8, PARITY = none, STOP = 1
	ldi		temp1, (1<<UCSZ01) | (1<<UCSZ00)
	sts		UCSR0C, temp1
}

    UCSR0C := %10000110;


end INIT_SER_PORT;






procedure sende_Zeichen;
begin
  // wenn UDRE0 gesetzt ist, so ist der Puffer leer
  // -> warten solange UDRE0 = 0  
  while BitLow(UDRE0) do
    SetBit(LED_ROT); // rot ein
  endwhile;

  ClearBit(LED_ROT); // rot aus

  UDR0:=Zeichen;

end sende_Zeichen; 








procedure RX_Puffer_abfragen;
begin
  // wurde ein Byte durch die UART empfangen, so ist das RXC0-Bit gesetzt 
  // ist RXC0-Bit = 0, dann ist der Empfangs-Puffer leer
  if BitHigh(RXC0) then
    empfangenes_Zeichen:=UDR0;
  endif; { if BitHigh(RXC0) then }
end RX_Puffer_abfragen;








BEGIN

ASM;

.equ UBRR0 = UBRR0L

ENDASM;



END test_ser.
