; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: SOUND.PAS
 
.nolist
.INCLUDE "m8def.inc"
.list
 
; *** Variablentabelle ***
 
.dseg
 
ZEICHEN:   ; Byte
.byte     1
FREQUENZ:   ; Word
.byte     2
TONLAENGE:   ; Word
.byte     2
LAMPE_AN:   ; Boolean
.byte     1
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        RJMP       RESET
 
; Timer/Counter0 Overflow
.ORG OVF0addr
        RJMP       TIMER0_OVF
 
; ISR - Einsprung
TIMER0_OVF:
        PUSH       R16
        IN         R16,SREG
        PUSH       R16
 
; INC(TONLAENGE) - Word
        LDS        R24, TONLAENGE
        LDS        R25, TONLAENGE+1
        ADIW       R25:R24, 1
        STS        TONLAENGE, R24
        STS        TONLAENGE+1, R25
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (TONLAENGE)
        LDS        R16, TONLAENGE
        LDS        R17, TONLAENGE+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x1388)
        LDI        R18, LOW(0x1388)
        LDI        R19, HIGH(0x1388)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_04
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_05
M_VERGL_04:
        SER        R16
M_VERGL_05:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01
        RJMP       M_IF_02
M_IF_01:
 
; IF THEN - Ausdruck / Byte-VAR (LAMPE_AN)
        LDS        R16, LAMPE_AN
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_06
        RJMP       M_IF_07
M_IF_06:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LAMPE_AN)
        STS        LAMPE_AN, R16
 
; ClearBit(LED_GRUEN)
        CBI        PORTC, 0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_08
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_07:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (LAMPE_AN)
        STS        LAMPE_AN, R16
 
; SetBit(LED_GRUEN)
        SBI        PORTC, 0
 
; IF_THEN_ELSE - Ende
M_IF_08:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (TONLAENGE)
        STS        TONLAENGE, R16
        STS        TONLAENGE+1, R17
 
; IF_THEN - Ende
M_IF_02:
 
; ISR - Ende
        POP        R16
        OUT        SREG,R16
        POP        R16
        RETI
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFC)
        LDI        R16, 0xFC
 
; Zuweisung Ziel /  VAR (DDRD)
        OUT        DDRD, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Aufruf PROCEDURE (INITPORTS)
        RCALL      INITPORTS
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TCCR0)
        OUT        TCCR0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TIMSK)
        OUT        TIMSK, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (TONLAENGE)
        STS        TONLAENGE, R16
        STS        TONLAENGE+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LAMPE_AN)
        STS        LAMPE_AN, R16
 
; ClearBit(LED_GRUEN)
        CBI        PORTC, 0
 
; ASM
    SEI

 
 
; LOOP - Start_Marke
M_LOOP_09:
 
; LOOP - Ende
        RJMP       M_LOOP_09
 
; *** Namen-Liste ***
;
; SREG (V) BYTECONREG
; SPH (V) BYTECONREG
; SPL (V) BYTECONREG
; GICR (V) BYTECONREG
; GIFR (V) BYTECONREG
; TIMSK (V) BYTECONREG
; TIFR (V) BYTECONREG
; SPMCR (V) BYTECONREG
; TWCR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUCSR (V) BYTECONREG
; MCUSR (V) BYTECONREG
; TCCR0 (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; OSCCAL (V) BYTECONREG
; SFIOR (V) BYTECONREG
; TCCR1A (V) BYTECONREG
; TCCR1B (V) BYTECONREG
; TCNT1H (V) BYTECONREG
; TCNT1L (V) BYTECONREG
; OCR1AH (V) BYTECONREG
; OCR1AL (V) BYTECONREG
; OCR1BH (V) BYTECONREG
; OCR1BL (V) BYTECONREG
; ICR1H (V) BYTECONREG
; ICR1L (V) BYTECONREG
; TCCR2 (V) BYTECONREG
; TCNT2 (V) BYTECONREG
; OCR2 (V) BYTECONREG
; ASSR (V) BYTECONREG
; WDTCR (V) BYTECONREG
; UBRRH (V) BYTECONREG
; UBRRL (V) BYTECONREG
; UCSRC (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; UCSRA (V) BYTECONREG
; UCSRB (V) BYTECONREG
; ACSR (V) BYTECONREG
; ADMUX (V) BYTECONREG
; ADCSR (V) BYTECONREG
; ADCSRA (V) BYTECONREG
; ADCH (V) BYTECONREG
; ADCL (V) BYTECONREG
; TWDR (V) BYTECONREG
; TWAR (V) BYTECONREG
; TWSR (V) BYTECONREG
; TWBR (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; EEAR (V) WORDCONREG
; TCNT1 (V) WORDCONREG
; OCR1A (V) WORDCONREG
; OCR1B (V) WORDCONREG
; ICR1 (V) WORDCONREG
; ADCHL (V) WORDCONREG
; RXC (B) BIT
; TXC (B) BIT
; UDRE (B) BIT
; SUMMER (B) BIT
; LED_GRUEN (B) BIT
; ZEICHEN (V) BYTE
; FREQUENZ (V) WORD
; TONLAENGE (V) WORD
; LAMPE_AN (V) BOOLEAN
; INITPORTS (P) 
 
; *** Prozedur/Function-Liste ***
;
; PROCEDURE INITPORTS;
 
; *** ISR-Liste ***
;
; Nummer=2    ORG=INT0addr     ISR=INT0          Bemerkung=External Interrupt Request 0
; Nummer=3    ORG=INT1addr     ISR=INT1          Bemerkung=External Interrupt Request 1
; Nummer=4    ORG=OC2addr      ISR=TIMER2_COMP   Bemerkung=Timer/Counter2 Compare Match
; Nummer=5    ORG=OVF2addr     ISR=TIMER2_OVF    Bemerkung=Timer/Counter2 Overflow
; Nummer=6    ORG=ICP1addr     ISR=TIMER1_CAPT   Bemerkung=Timer/Counter1 Capture Event
; Nummer=7    ORG=OC1Aaddr     ISR=TIMER1_COMPA  Bemerkung=Timer/Counter1 Compare Match A
; Nummer=8    ORG=OC1Baddr     ISR=TIMER1_COMPB  Bemerkung=Timer/Counter1 Compare Match B
; Nummer=9    ORG=OVF1addr     ISR=TIMER1_OVF    Bemerkung=Timer/Counter1 Overflow
; Nummer=10   ORG=OVF0addr     ISR=TIMER0_OVF    Bemerkung=Timer/Counter0 Overflow
; Nummer=11   ORG=SPIaddr      ISR=SPI_STC       Bemerkung=Serial Transfer Complete
; Nummer=12   ORG=URXCaddr     ISR=USART_RXC     Bemerkung=USART, Rx Complete
; Nummer=13   ORG=UDREaddr     ISR=USART_UDRE    Bemerkung=USART Data Register Empty
; Nummer=14   ORG=UTXCaddr     ISR=USART_TXC     Bemerkung=USART, Tx Complete
; Nummer=15   ORG=ADCCaddr     ISR=ADC_CC        Bemerkung=ADC Conversion Complete
; Nummer=16   ORG=ERDYaddr     ISR=EE_RDY        Bemerkung=EEPROM Ready
; Nummer=17   ORG=ACIaddr      ISR=ANA_COMP      Bemerkung=Analog Comparator
; Nummer=18   ORG=TWIaddr      ISR=TWI           Bemerkung=Two-wire Serial Interface
; Nummer=19   ORG=SPMRaddr     ISR=SPM_RDY       Bemerkung=Store Program Memory Ready
 
