; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: MEGA.PAS
 
.nolist
.INCLUDE "m2560def.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        TAKTFREQUENZ  =  0x3E80 ; WORD
.equ        UBRR_VAL  =  0x05 ; BYTE
.equ        MATRIX_COL_MAX  =  0x004F ; WORD
.equ        MATRIX_ROW_MAX  =  0x0017 ; WORD
 
; *** Variablentabelle ***
 
.dseg
 
DBG_ANFANG_VAR_TABELLE:
 
X_KUR_POS:   ; Word
.byte     2
Y_KUR_POS:   ; Word
.byte     2
MAX_SPALTEN:   ; Word
.byte     2
MAX_ZEILEN:   ; Word
.byte     2
C_FCOLOR_BYTE:   ; Byte
.byte     1
 
FC_FARB_MATRIX:
.byte     1944
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        LDI   ZL,byte3(RESET)
        OUT   EIND,ZL
        LDI   ZL,low(RESET)
        LDI   ZH,high(RESET)
        EIJMP
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; FOR TO DO - Ausdruck / Word-VAR (MAX_SPALTEN)
        LDS        R16, MAX_SPALTEN
        LDS        R17, MAX_SPALTEN+1
 
; FOR TO DO - Laden des Word-Zaehlwertes
        LDS        R18, X_KUR_POS
        LDS        R19, X_KUR_POS+1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_01:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_02
        RJMP       M_FTD_03
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_02:
 
; VAR ARRAY-2D POSITION 01 - Ausdruck / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
        LDI        R18, LOW(0x0051)
        LDI        R19, HIGH(0x0051)
        LDI   ZL,byte3(ASM_UP_MUL16)
        OUT   EIND,ZL
        LDI   ZL,low(ASM_UP_MUL16)
        LDI   ZH,high(ASM_UP_MUL16)
        EICALL
        PUSH       R16
        PUSH       R17
 
; VAR ARRAY-2D POSITION 02 - Ausdruck / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
        POP        R19
        POP        R18
        ADD        R16, R18
        ADC        R17, R19
 
; VAR ARRAY Ziel Zeiger berechnen (FC_FARB_MATRIX)
        LDI        ZL, LOW(FC_FARB_MATRIX)
        LDI        ZH, HIGH(FC_FARB_MATRIX)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (C_FCOLOR_BYTE)
        LDS        R16, C_FCOLOR_BYTE
 
; Zuweisung Ziel /  VAR ARRAY-1D (FC_FARB_MATRIX)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (global)Word-INC-Zaehler
        LDS        R18, X_KUR_POS
        LDS        R19, X_KUR_POS+1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        STS        X_KUR_POS, R18
        STS        X_KUR_POS+1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_01
 
; FOR TO DO - Ende
M_FTD_03:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; LOOP - Start_Marke
M_LOOP_04:
 
; LOOP - Ende
        RJMP       M_LOOP_04
 
; *** Unterprogramm Bibliothek ***
; Multiplikation von 2 16-Bit Zahlen (WORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 11.01.2013
;
; Uebergabe: R16:R17 erster Faktor
;            R18:R19 zweiter Faktor
; Temporaere Register: R20,R21,R22,R23,R24 
;                      R2 ,R3  R4  R5  R6
ASM_UP_MUL16:
 
        PUSH       R0
        PUSH       R1

        CLR        R24
        MUL        R19, R17
        MOVW       R23:R22, R1:R0
        MUL        R18, R16
        MOVW       R21:R20, R1:R0
        MUL        R19, R16
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MUL        R17, R18
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MOVW       R17:R16, R21:R20       ; Produkt Low
        MOVW       R19:R18, R23:R22       ; Produkt High

        POP        R1
        POP        R0		

        RET






 
; *** Namen-Liste ***
;
; UDR0 (V) BYTECONVAR
; UBRR0H (V) BYTECONVAR
; UBRR0L (V) BYTECONVAR
; UCSR0A (V) BYTECONVAR
; UCSR0B (V) BYTECONVAR
; UCSR0C (V) BYTECONVAR
; UDR1 (V) BYTECONVAR
; UBRR1H (V) BYTECONVAR
; UBRR1L (V) BYTECONVAR
; UCSR1A (V) BYTECONVAR
; UCSR1B (V) BYTECONVAR
; UCSR1C (V) BYTECONVAR
; UDR2 (V) BYTECONVAR
; UBRR2H (V) BYTECONVAR
; UBRR2L (V) BYTECONVAR
; UCSR2A (V) BYTECONVAR
; UCSR2B (V) BYTECONVAR
; UCSR2C (V) BYTECONVAR
; UDR3 (V) BYTECONVAR
; UBRR3H (V) BYTECONVAR
; UBRR3L (V) BYTECONVAR
; UCSR3A (V) BYTECONVAR
; UCSR3B (V) BYTECONVAR
; UCSR3C (V) BYTECONVAR
; TWAMR (V) BYTECONVAR
; TWCR (V) BYTECONVAR
; TWDR (V) BYTECONVAR
; TWAR (V) BYTECONVAR
; TWSR (V) BYTECONVAR
; TWBR (V) BYTECONVAR
; OCR1AH (V) BYTECONVAR
; OCR1AL (V) BYTECONVAR
; OCR1BL (V) BYTECONVAR
; OCR1BH (V) BYTECONVAR
; OCR1CL (V) BYTECONVAR
; OCR1CH (V) BYTECONVAR
; ICR1L (V) BYTECONVAR
; ICR1H (V) BYTECONVAR
; TCNT1L (V) BYTECONVAR
; TCNT1H (V) BYTECONVAR
; TCCR1C (V) BYTECONVAR
; TCCR1B (V) BYTECONVAR
; TCCR1A (V) BYTECONVAR
; ASSR (V) BYTECONVAR
; OCR2B (V) BYTECONVAR
; OCR2A (V) BYTECONVAR
; TCNT2 (V) BYTECONVAR
; TCCR2B (V) BYTECONVAR
; TCCR2A (V) BYTECONVAR
; OCR3AL (V) BYTECONVAR
; OCR3AH (V) BYTECONVAR
; OCR3BL (V) BYTECONVAR
; OCR3BH (V) BYTECONVAR
; OCR3CL (V) BYTECONVAR
; OCR3CH (V) BYTECONVAR
; ICR3L (V) BYTECONVAR
; ICR3H (V) BYTECONVAR
; TCNT3L (V) BYTECONVAR
; TCNT3H (V) BYTECONVAR
; TCCR3A (V) BYTECONVAR
; TCCR3B (V) BYTECONVAR
; TCCR3C (V) BYTECONVAR
; OCR4AL (V) BYTECONVAR
; OCR4AH (V) BYTECONVAR
; OCR4BL (V) BYTECONVAR
; OCR4BH (V) BYTECONVAR
; OCR4CL (V) BYTECONVAR
; OCR4CH (V) BYTECONVAR
; ICR4L (V) BYTECONVAR
; ICR4H (V) BYTECONVAR
; TCNT4L (V) BYTECONVAR
; TCNT4H (V) BYTECONVAR
; TCCR4A (V) BYTECONVAR
; TCCR4B (V) BYTECONVAR
; TCCR4C (V) BYTECONVAR
; OCR5AL (V) BYTECONVAR
; OCR5AH (V) BYTECONVAR
; OCR5BL (V) BYTECONVAR
; OCR5BH (V) BYTECONVAR
; OCR5CL (V) BYTECONVAR
; OCR5CH (V) BYTECONVAR
; ICR5L (V) BYTECONVAR
; ICR5H (V) BYTECONVAR
; TCNT5L (V) BYTECONVAR
; TCNT5H (V) BYTECONVAR
; TCCR5A (V) BYTECONVAR
; TCCR5B (V) BYTECONVAR
; TCCR5C (V) BYTECONVAR
; TIMSK0 (V) BYTECONVAR
; TIMSK1 (V) BYTECONVAR
; TIMSK2 (V) BYTECONVAR
; TIMSK3 (V) BYTECONVAR
; TIMSK4 (V) BYTECONVAR
; TIMSK5 (V) BYTECONVAR
; DIDR0 (V) BYTECONVAR
; DIDR1 (V) BYTECONVAR
; DIDR2 (V) BYTECONVAR
; ADMUX (V) BYTECONVAR
; ADCSRB (V) BYTECONVAR
; ADCSRA (V) BYTECONVAR
; ADCH (V) BYTECONVAR
; ADCL (V) BYTECONVAR
; PCMSK0 (V) BYTECONVAR
; PCMSK1 (V) BYTECONVAR
; PCMSK2 (V) BYTECONVAR
; EICRA (V) BYTECONVAR
; EICRB (V) BYTECONVAR
; PCICR (V) BYTECONVAR
; XMCRA (V) BYTECONVAR
; XMCRB (V) BYTECONVAR
; PORTH (V) BYTECONVAR
; DDRH (V) BYTECONVAR
; PINH (V) BYTECONVAR
; PORTJ (V) BYTECONVAR
; DDRJ (V) BYTECONVAR
; PINJ (V) BYTECONVAR
; PORTK (V) BYTECONVAR
; DDRK (V) BYTECONVAR
; PINK (V) BYTECONVAR
; PORTL (V) BYTECONVAR
; DDRL (V) BYTECONVAR
; PINL (V) BYTECONVAR
; OSCCAL (V) BYTECONVAR
; PRR0 (V) BYTECONVAR
; PRR1 (V) BYTECONVAR
; CLKPR (V) BYTECONVAR
; WDTCSR (V) BYTECONVAR
; SREG (V) BYTECONREG
; SPL (V) BYTECONREG
; SPH (V) BYTECONREG
; SPMCSR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUSR (V) BYTECONREG
; SMCR (V) BYTECONREG
; OCDR (V) BYTECONREG
; ACSR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; GPIOR0 (V) BYTECONREG
; GPIOR1 (V) BYTECONREG
; GPIOR2 (V) BYTECONREG
; OCR0A (V) BYTECONREG
; OCR0B (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; TCCR0A (V) BYTECONREG
; TCCR0B (V) BYTECONREG
; GTCCR (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; EIMSK (V) BYTECONREG
; EIFR (V) BYTECONREG
; PCIFR (V) BYTECONREG
; TIFR0 (V) BYTECONREG
; TIFR1 (V) BYTECONREG
; TIFR2 (V) BYTECONREG
; TIFR3 (V) BYTECONREG
; TIFR4 (V) BYTECONREG
; TIFR5 (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; PORTE (V) BYTECONREG
; DDRE (V) BYTECONREG
; PINE (V) BYTECONREG
; PORTF (V) BYTECONREG
; DDRF (V) BYTECONREG
; PINF (V) BYTECONREG
; PORTG (V) BYTECONREG
; DDRG (V) BYTECONREG
; PING (V) BYTECONREG
; RAMPZ (V) BYTECONREG
; EIND (V) BYTECONREG
; TAKTFREQUENZ (C) WORD Wert=0x3E80
; UBRR_VAL (C) BYTE Wert=0x05
; MATRIX_COL_MAX (C) WORD Wert=0x004F
; MATRIX_ROW_MAX (C) WORD Wert=0x0017
; X_KUR_POS (V) WORD
; Y_KUR_POS (V) WORD
; MAX_SPALTEN (V) WORD
; MAX_ZEILEN (V) WORD
; C_FCOLOR_BYTE (V) BYTE
; FC_FARB_MATRIX (Z) BYTE Procedure=
 
