; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TEST_ARRAY.PAS
 
.nolist
.INCLUDE "m8def.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        C1  =  0x0009 ; WORD
 
; *** Variablentabelle ***
 
.dseg
 
DBG_ANFANG_VAR_TABELLE:
 
B1:   ; Byte
.byte     1
W1:   ; Word
.byte     2
W2:   ; Word
.byte     2
 
A1:
.byte     41
A3:
.byte     50
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        RJMP       RESET
 
; PROCEDURE - Anfang (P1)
P1:
 
; ARRAY-2D - 1.Parameter - Ausdruck / Word-VAR (W1)
        LDS        R16, W1
        LDS        R17, W1+1
 
; Laenge 2. ARRAY-Dimension in R18 und R19
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Multiplikation erster ARRAY-Parameter (D1) mit Laenge 2. Dimension
        RCALL      ASM_UP_MUL16
 
; Ergebnisses der Multiplikation D1 * (Laenge D2) in den Stack 
        PUSH       R16
        PUSH       R17
 
; ARRAY-2D - 2.Parameter - Ausdruck / Word-VAR (W2)
        LDS        R16, W2
        LDS        R17, W2+1
 
; Rueckholen des Ergebnisses der Multiplikation D1 * (Laenge D2) vom Stack
        POP        R19
        POP        R18
 
; (Position 1D * Laenge 2D) + Position 2D
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (A3)
        LDI        ZL, LOW(A3)
        LDI        ZH, HIGH(A3)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (B1)
        STS        B1, R16
 
; PROCEDURE - Ende (P1)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
 
; *** Unterprogramm Bibliothek ***
; Multiplikation von 2 16-Bit Zahlen (WORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 11.01.2013
;
; Uebergabe: R16:R17 erster Faktor
;            R18:R19 zweiter Faktor
; Temporaere Register: R20,R21,R22,R23,R24 
;                      R2 ,R3  R4  R5  R6
ASM_UP_MUL16:
 
        PUSH       R0
        PUSH       R1

        CLR        R24
        MUL        R19, R17
        MOVW       R23:R22, R1:R0
        MUL        R18, R16
        MOVW       R21:R20, R1:R0
        MUL        R19, R16
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MUL        R17, R18
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MOVW       R17:R16, R21:R20       ; Produkt Low
        MOVW       R19:R18, R23:R22       ; Produkt High

        POP        R1
        POP        R0		

        RET






 
; *** Namen-Liste ***
;
; C1 (C) WORD Wert=0x0009
; B1 (V) BYTE
; W1 (V) WORD
; W2 (V) WORD
; A1 (Y) BYTE
; A3 (Z) BYTE Procedure=
; P1 (P) 
 
; *** Prozedur/Function-Liste ***
;
; PROCEDURE P1;
 
